unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, uKlassen, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    Button2: TButton;
    Edit1: TEdit;
    ListBox2: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure abarbeiten(Sender: Tobject);
    procedure pali_check(Sender: Tobject);
    procedure Button2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
//*****fr die Schlange:
  q1:Tqueue;
  s1:Tstack;
  t1:TTimer;
  zaehler:integer;
//*****fr den Stapel:
  t2:tTimer;
  laenge,mitte:integer;
  bidm:integer; //Wenn Buchstabe in der Mitte zB bei "anina", muss der beim Prfen bersprungen werden
  s:string;
  marker: integer; // markiert, wo im Wort ich bin
  fehler:boolean;
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
zaehler:=0;
q1:=Tqueue.Create;
s1:=tstack.Create;
// Timer selbst erzeugen:
//1. Timer fr die Schlange
t1:=ttimer.Create(nil);
t1.Enabled:=false;
t1.Interval:=3000;
t1.OnTimer:=abarbeiten;
//2. Timer fr den Stapel
t2:=ttimer.Create(nil);
t2.Enabled:=false;
t2.Interval:=1000;
t2.OnTimer:=pali_check;
end;

// ********* Methoden fr die Schlange *****************
procedure Tform1.abarbeiten(Sender: TObject);
begin
  if listbox1.Items.Count>0 then
  begin
    q1.dequeue;
    listbox1.Items.Text:=q1.ausgabe;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
inc(zaehler);
if not t1.Enabled then t1.Enabled:=true;
q1.enqueue('Kunde '+inttostr(zaehler) );
listbox1.Items.Text:=q1.ausgabe;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
fehler:=false;
 s:=uppercase(edit1.Text);
 laenge:=length(s);
 mitte:=laenge div 2;
 if laenge mod 2=0 then bidm:=0 else bidm:=1; // Wenn ungerade, ist ein Buchstabe in der Mitte s.o.
 marker:=0;
 t2.Enabled:=true;


end;

// ********* Methoden fr den Stapel  *****************

procedure Tform1.pali_check(Sender: TObject);
begin
 inc(marker);
 if marker<=mitte then
  begin
    s1.push(s[marker]);
    listbox2.Items.Text:=s1.ausgabe;
  end else
 if (marker>mitte+bidm) AND (marker<laenge) then
  begin
    if s1.oben=s[marker] then s1.pop else
    fehler:=true;
    listbox2.Items.Text:=s1.ausgabe;
  end;
if marker=laenge then
 begin
   if fehler  then showmessage ('Keins') else showmessage('Ist eins');
   t2.Enabled:=false;
   s1.leeren;
   listbox2.Items.Text:=s1.ausgabe;
 end;

end;



end.
